/*                                    */
/*   98 -kuha-   Ver0.1 (2005/05/08)  */
/*              (c) 2005 Akkiesoft.   */
/*                                    */
/* Stack:64k, Malloc:256k, File:0     */
/*                                    */

#include <guigui00.h>

#define	AUTO_MALLOC	0

static int MALLOC_ADDR;
#define malloc(bytes)		(void *) (MALLOC_ADDR -= ((bytes) + 7) & ~7)
#define free(addr)			for (;;); /* freeĂ͍̂ŉiv[v */

static struct LIB_TEXTBOX *textbox;

void wait(int a, int b, int c)
{
	lib_waitsignaltime(0x0f, 0, 0, a * 4294967, b, c);
	return;
}

void putstr(char *s, int x, int y, int l)
{
	lib_putstring1(0x1000, x, y, textbox, 15, 0, 0, l, s);
	return;
}

void OsaskMain()
{
	struct LIB_WINDOW *window;
	struct LIB_TEXTBOX *wintitle;

	int i;

	MALLOC_ADDR = lib_readCSd(0x0010);
	lib_init(AUTO_MALLOC);

	window = lib_openwindow(AUTO_MALLOC, 0x0200, 480, 304);
	wintitle = lib_opentextbox(0x1000, AUTO_MALLOC, 0,  4, 1,  0,  0, window, 0x00c0, 0);
		lib_putstring1(0x1000, 0, 0, wintitle, 0, 0, 0, 4, "kuha");
	textbox  = lib_opentextbox(1, AUTO_MALLOC, 0, 60, 19, 0, 0, window, 0x00c0, 0);

	lib_opensoundtrack(0x0210);		// Sound track.

reboot:
	wait(0, 1, 0);

	lib_controlfreq(0x210, 0x20C49B);	// 2.4576Mhz / 0x4cd == 2001 => 2000
	wait( 50, 0, 0);
	lib_controlfreq(0x210, 0x418937);
	wait( 50, 0, 0);
	lib_controlfreq(0x210, 0);
	wait(250, 0, 0);

	putstr("CPU MODE  High", 0, 0, 14);
	wait(100, 0, 0);
	putstr("MEMORY 128KB OK", 0, 1, 15);
	wait(150, 0, 0);
	putstr("256", 7, 1, 3);
	wait(150, 0, 0);
	putstr("384", 7, 1, 3);
	wait(150, 0, 0);
	putstr("512", 7, 1, 3);
	wait(150, 0, 0);
	putstr("640", 7, 1, 3);
	wait(150, 0, 0);

	putstr( "+  128KB OK  ", 13, 1, 14);
	wait(75, 0, 0);

	for (i = 256; i < 5121; i += 128) {
		char s[5];
		int j = 3, ic = i;

		do {
			s[j--] = (ic % 10) + '0';
			if ((ic /= 10) == 0)
				break;
		} while (j >= 0);
		while (j >= 0)
			s[j--] = ' ';

		putstr(s, 15, 1, 4);
		wait(75, 0, 0);
	}
	wait(0, 2, 0);

	putstr("                         ", 0, 0, 25);
	putstr("                         ", 0, 1, 25);

	goto reboot;
}
