/* ---------------------------------------------------------------- */
/*  CSVV :: CSV-Viewer   Ver.0.3(2006/10/20)   (c) 2006 Akkiesoft.  */
/*   TAB = 4      Stack: 512K  Malloc: 512K  MMArea: 1024K          */
/* ---------------------------------------------------------------- */

#include <guigui00.h>
#include <stdlib.h>
#include "scroll.h"

/* OtBbN{bNXɕ` */
#define	my_putstringg0(opt, x0, y0, gbox, col, bcol, charset, base, len, ofs) \
	lib_execcmd0(0x0114, (int) (opt), (int) (x0), (int) (y0), (void *) (gbox), \
		(int) (col), (int) (bcol), (int) (charset), (int) (base), (int) (len), \
		(void *) (ofs), (int) 0x000c, 0x0000)


/* --- ݒ荀 ----------- */
#define MAX_COMMA_X		201			// Ήłx̃Z(R}P. 676R炢x)
#define MAX_COMMA_Y		201			// Ήłx̃Z(R}P)
#define CELLSIZ_X		82			// x̃Z1̃TCY
#define CELLSIZ_Y		18			// ỹZ1̃TCY
/* ------------------------ */


#define	AUTO_MALLOC		0
#define REWIND_CODE		1

// OtBbN{bNX̃TCY
  #define WRKSEAT_X		CELLSIZ_X * maxell_x		// [NV[gX
  #define WRKSEAT_Y		CELLSIZ_Y * maxell_y		// [NV[gY
  #define GBOX_X		WRKSEAT_X + 17				// {bNXS(o[)X
  #define GBOX_Y		WRKSEAT_Y + 17				// {bNXS(o[)Y
// TextBox, Window
  #define TBOX_X		(GBOX_X) / 8				// TextboxTCYX
  #define WND_X			GBOX_X						//  WindowTCYX
  #define WND_Y			GBOX_Y + 16 /* TBOX_Y */	//  WindowTCYY


struct CSV_INFO {
	int comma[MAX_COMMA_Y][MAX_COMMA_X];
	int wsx, wsy;
	int filesize;
	unsigned char *fp;
};
static struct LIB_GRAPHBOX *field;
static struct LIB_TEXTBOX *value;
static int maxell_x =  7;	/*  */
static int maxell_y = 16;	/* s */
static int *signalbox0, *sig_ptr;


int setdec(int i, char *s, int j);
int GetCellData(unsigned char *s, struct CSV_INFO *csvinfo, int i, int l);
void DrawWorkSeat(int bx, int by, struct CSV_INFO *csvinfo, struct SCROLLBAR *tate, struct SCROLLBAR *yoko);
void Putcellinfo(int x, int y, struct CSV_INFO *csvinfo);
void my_drawboxId(int c, int idx, int idy);
void openwin(struct LIB_WINDOW *window, struct LIB_TEXTBOX *title, struct SCROLLBAR *tate, struct SCROLLBAR *yoko, int wx, int wy);
const int getsignal();


void OsaskMain()
{
	struct LIB_WINDOW *window;
	struct LIB_TEXTBOX *title;
	struct SCROLLBAR *tatebar, *yokobar;
	struct CSV_INFO csvinfo;
	int dispsize[2], mode, flag, runlevel;
	int sig, areasize, i, cx, cy, basex, basey;
	int *p_com1, *p_com2;
	unsigned char c;

	runlevel = cx = cy = basex = basey = csvinfo.wsx = csvinfo.wsy = 0;
	flag = -1;

	/* Av */
	lib_init(AUTO_MALLOC);
	sig_ptr = signalbox0 = lib_opensignalbox(256, AUTO_MALLOC, 0, REWIND_CODE);

	/* 𑜓x擾 */
	lib_execcmd0(0x0014, 0x0010, dispsize, 0x000c, 0x0000);

	/* 낢malloc */
	window   = malloc(sizeof (struct LIB_WINDOW  ));
	title    = malloc(sizeof (struct LIB_TEXTBOX ) + 10 * 8);
	value    = malloc(sizeof (struct LIB_TEXTBOX ) + dispsize[0]/* /8*8 */);  // v
	field    = malloc(sizeof (struct LIB_GRAPHBOX) + dispsize[1] * dispsize[0] + 64);
	tatebar  = malloc(sizeof (struct SCROLLBAR   ));
	yokobar  = malloc(sizeof (struct SCROLLBAR   ));
	areasize = lib_readCSd(0x0014) & ~0xfff;

	openwin(window, title, tatebar, yokobar, WND_X, WND_Y);

	for (;;) {
		if (flag < 0) {
			/* NAt@CI[v_CAOJ */
			flag++;
			goto fileopen;
		}

		lib_waitsignal(0x0001, 0, 0);
		sig = getsignal();

		if (sig == 40)
			continue;

		if (runlevel == 1) {
			/* t@CJẴL[ */
			if (sig == 4) { /* left */
				if (1 < cx) {
					my_drawboxId(7, cx, cy);
					cx--;
				} else if (1 < basex)
					basex--;
				else
					continue;
				goto redraw;
			}
			if (sig == 5) { /* rigth */
				if (cx < maxell_x-1) {
					my_drawboxId(7, cx, cy);
					cx++;
				} else if (basex+cx < MAX_COMMA_X && basex+cx < csvinfo.wsx)
					basex++;
				else
					continue;
				goto redraw;
			}
			if (sig == 6) { /* up */
				if (cy > 1) {
					my_drawboxId(7, cx, cy);
					cy--;
				} else if (1 < basey)
					basey--;
				else
					continue;
				goto redraw;
			}
			if (sig == 7) { /* down */
				if (cy <  maxell_y-1) {
					my_drawboxId(7, cx, cy);
					cy++;
				} else if (basey+cy < MAX_COMMA_Y && basey+cy < csvinfo.wsy)
					basey++;
				else
					continue;
				goto redraw;
			}

			if (sig == 8) { /* Page Up */
				if (basey > 1) {
					basey -= maxell_y - 1;
					if (basey < 1) {
						my_drawboxId(7, cx, cy);
						basey = cy = 1;
					}
					goto redraw;
				}
			}
			if (sig == 9) { /* Page Down */
				if (basey <= csvinfo.wsy - maxell_y) {
					basey += maxell_y - 1;
					if (csvinfo.wsy - maxell_y < basey) {
						
						basey = csvinfo.wsy - maxell_y + 1;
						my_drawboxId(7, cx, cy);
						cy = maxell_y - 1;
					}
					goto redraw;
				}
			}
		}

		if (sig == 10) { /* WindowSizeύX: left */
			if (maxell_x < 4)
				continue;
			maxell_x--;
		}
		if (sig == 11) { /* WindowSizeύX: rigth */
			if (dispsize[0] <= WND_X + CELLSIZ_X)
				continue;
			maxell_x++;
		}
		if (sig == 12) { /* WindowSizeύX: up */
			if (maxell_y < 4)
				continue;
			maxell_y--;
		}
		if (sig == 13) { /* WindowSizeύX: down */
			if (dispsize[1] <= WND_Y + CELLSIZ_Y)
				continue;
			maxell_y++;
		}
		if (9 < sig && sig < 14) {
			lib_closewindow(0, window);
			do {
				lib_waitsignal(0x0001, 0, 0);
			} while (getsignal() != 40);
			openwin(window, title, tatebar, yokobar, WND_X, WND_Y);
			if (0 < runlevel)
				goto reset;
			continue;
		}

		if (sig == 14) {
fileopen:
			/* t@CI[v */
			lib_unmapmodule(0, areasize, csvinfo.fp);
			lib_initmodulehandle1(0x0260, 1, 16/* sig */);
			continue;
		}
		if (16 < sig && sig < 32)
			continue;
		if (sig == 16) {
			if ((csvinfo.filesize = lib_readmodulesize(0x0260)) > areasize) {
				lib_putstring1(0x1000, 0, 0, value, 0, 0, 0, 18, "Filesize over! orz");
				continue;
			}

			// J[\
			my_drawboxId(7, cx, cy);

			csvinfo.fp = (char *) lib_readCSd(0x0010);
			lib_mapmodule(0x0000, 0x0260, 0x5, areasize, csvinfo.fp, 0);

			/* CSVf[^̏ */
			p_com2 = &csvinfo.comma[MAX_COMMA_Y - 1][MAX_COMMA_X - 1];
			for (p_com1 = &csvinfo.comma[0][0]; p_com1 <= p_com2; p_com1++)
				*p_com1 = -1;

			i = cx = cy = mode = csvinfo.wsx = csvinfo.wsy = 0;
			if (csvinfo.fp[0] != ',')
				csvinfo.comma[0][0] = 0;

			while (i < csvinfo.filesize) {
				c = csvinfo.fp[i++];
				if (c == 0x22/* " */) {
					if  (i == 1 || mode == 0) {
						mode++;
						continue;
					}
					if (mode && (csvinfo.fp[i] == ',' || csvinfo.fp[i] == 0x0a || csvinfo.fp[i] == 0x0d))
						mode--;
				}

				if (mode == 0 && c == ',') {
					cx++;
					// u,,vu,\nv̂悤ɁAZɉȂԂł͂Ȃ
					if (csvinfo.fp[i] != ',' && csvinfo.fp[i] != 0x0a && csvinfo.fp[i] != 0x0d)
						csvinfo.comma[cy][cx] = i;		// R}̎̏̕ꏊL^
				}

				/* sR[h */
				if ((c == 0x0d /* CR */ && csvinfo.fp[i] == 0x0a /* LF */) ||
					(c == 0x0a /* LF */ && csvinfo.fp[i] == 0x0d /* CR */)) {
					if (i < csvinfo.filesize) {
						i++;
						if (i >= csvinfo.filesize)
							break;
						if (csvinfo.wsx < cx)
							csvinfo.wsx = cx + 2;
						cx = 0;
						cy++;
						if (csvinfo.fp[i] != ',' && csvinfo.fp[i] != 0x0a && csvinfo.fp[i] != 0x0d)
							csvinfo.comma[cy][cx] = i;		// R}̎̏̕ꏊL^
						if (csvinfo.fp[i] == 0x22)
							mode++;
					}
				}
			}
			if (csvinfo.wsy < cy)
				csvinfo.wsy = cy + 2;
			if (csvinfo.wsx < maxell_x)
				csvinfo.wsx = maxell_x;
			if (csvinfo.wsy < maxell_y)
				csvinfo.wsy = maxell_y;

			runlevel = 1;

			/* CSVf[^\ */
reset:
			cx = cy = basex = basey = 1;
redraw:
			DrawWorkSeat(basex, basey, &csvinfo, tatebar, yokobar);
			my_drawboxId(12, cx, cy);
			Putcellinfo(basex+cx-2, basey+cy-2, &csvinfo);

		}
	}

}


int setdec(int i, char *s, int j/* '\0' */)
/* lis̉EjBŌɑs̈ʒu-1ԂB */
{
	do {
		s[j--] = (i % 10) + '0';
		if ((i /= 10) == 0)
			break;
	} while (j >= 0);
	return j;
}

int GetCellData(unsigned char *s, struct CSV_INFO *csvinfo, int i, int l)
/* Z̕oB */
{
	int j = 0, mode = 0;
	unsigned char c;

	if (i < 0)
		return -1;

	if (csvinfo->fp[i] == 0x22) {
		i++;
		mode++;
	}

	for (;;) {
		c = csvinfo->fp[i++];

		/* t@C̏I[ɓB */
		if (i > csvinfo->filesize)
			break;

		/* sR[hƂA""[hOFF̎̃R}o͏I */
		if (c == 0x0d /* CR */ || c == 0x0a /* LF */ || (mode == 0 && c == ','))
			break;

		if (mode && c == 0x22 /* " */) {
			if (csvinfo->fp[i] == ',' || csvinfo->fp[i] == 0x0a || csvinfo->fp[i] == 0x0d)
				break;
			if (csvinfo->fp[i] == 0x22 && csvinfo->fp[i+1] != ',' && csvinfo->fp[i+1] != 0x0a && csvinfo->fp[i+1] != 0x0d)
				i++;
		}

		/* \֕ϊ */
		if (j < l) {
			if (c == '\t' /* Tab */)
				j += 3;	// tab == 4 (if,else𔲂Ƃj++4ɂȂ)
			else if (0xa1 <= c && c <= 0xdf)
				s[j] = c;
			else if (0x81 <= c && c <= 0xef && i < csvinfo->filesize && 0x40 <= csvinfo->fp[i]) {
				if (j+1 < l) {
					s[j++] = c;
					s[j] = csvinfo->fp[i++];
				}
			} else
				s[j] = c;
			j++;
		}
	}

	return j;
}

void DrawWorkSeat(int bx, int by, struct CSV_INFO *csvinfo, struct SCROLLBAR *tate, struct SCROLLBAR *yoko)
{
	int len = 10; // ̒
	int i, o[len+1], tx = bx, ty = by, y;
	unsigned char s[len+1];
	s[10] = '\0';

	for (i = 0; i < len; i++) {s[i] = ' ';}
	for (i = 1; i < maxell_y; i++) {
		setdec(ty, s, 5);
		ty++;
		my_putstringg0(0x5100, 2, CELLSIZ_Y*i+2, field, 15, 4, 0x00c0, 0, len, s);
	}

	for (i = 0; i < len; i++) {s[i] = ' ';}
	i = 1;
	for (;;) {
		tx = bx + i - 2;
		if (tx > 25)
			s[4] = 0x40 + (tx / 26);
		s[5] = 0x41 + (tx % 26);
		my_putstringg0(0x5100, CELLSIZ_X*i+2, 2, field, 15, 4, 0x00c0, 0, len, s);
		i++;
		if (i >= maxell_x)
			break;
	}

	/* Read file */
	for (y = 1; y < maxell_y; y++) {
		int x;
		for (x = 1; x < maxell_x; x++) {
			tx = bx+x-2;	// tx, tyTCN
			ty = by+y-2;

			for (i = 0; i < len; i++) {s[i] = ' ';}
			i = GetCellData(s, csvinfo, csvinfo->comma[ty][tx], len);
			if (i < 0) {
				my_putstringg0(0x5100, CELLSIZ_X*x+2, CELLSIZ_Y*y+2, field, 0, 15, 0x0210, 0, len, s);
				continue;
			}
			lib_wsjis2gg00jpn0(len, s, o, 0x4e00, 0x0400);
			my_putstringg0(0x4100, CELLSIZ_X*x+2, CELLSIZ_Y*y+2, field, 0, 15, 0x0210, 0, len, o);
		}
	}

	/* Scroll bar */
	scroll_setbar(yoko, maxell_x-1, csvinfo->wsx-1, bx-1);
	scroll_setbar(tate, maxell_y-1, csvinfo->wsy-1, by-1);

	return;
}

void Putcellinfo(int x, int y, struct CSV_INFO *csvinfo)
/* ZԒn̕\ */
{
	int i, o[TBOX_X + 1];
	unsigned char s[TBOX_X + 1];

	for (i = 0; i < TBOX_X; i++) {s[i] = ' ';}
	s[0] = '(';
	s[9] = ')';
	s[TBOX_X] = '\0';

	i = setdec(y + 1, s, 7);	// ͍sԍ
	s[i--] = 0x41 + (x % 26);	// ԍ
	if (x > 25)
		s[i] = 0x40 + (x / 26);
	lib_putstring1(0x1000, 0, 0, value, 0, 0, 0, TBOX_X, s);	// \1

	i = GetCellData(s, csvinfo, csvinfo->comma[y][x], TBOX_X-12);
	if (i >= 0) {
		lib_wsjis2gg00jpn0(i, s, o, 0x4e00, 0x0400);
		lib_putstring0(0x0000, 10, 0, value, 0, 0, i, o);	// \2
	}
	return;
}


void my_drawboxId(int c, int idx, int idy)
{
	idx *= CELLSIZ_X;
	idy *= CELLSIZ_Y;
	lib_drawline0(0, field, c, idx          , idy          , idx+CELLSIZ_X, idy          );
	lib_drawline0(0, field, c, idx          , idy+CELLSIZ_Y, idx+CELLSIZ_X, idy+CELLSIZ_Y);
	lib_drawline0(0, field, c, idx          , idy          , idx          , idy+CELLSIZ_Y);
	lib_drawline0(0, field, c, idx+CELLSIZ_X, idy          , idx+CELLSIZ_X, idy+CELLSIZ_Y);
	return;
}

void openwin(struct LIB_WINDOW *window, struct LIB_TEXTBOX *title, struct SCROLLBAR *tate, struct SCROLLBAR *yoko, int wx, int wy)
{
	int i;
	static int fontflag = 0;

	lib_openwindow1_nm(window, 0x0200, wx, wy, 0x20/* WindowCloseʒm(+7) */, 40 - 7/* +7ł */);
	lib_opentextbox_nm(0x1000, title, 0,  10, 1,  0,  0, window, 0x00c0, 0);
	lib_putstring1(0x1000, 0, 0, title, 0, 0, 0, 10, "CSV-Viewer");

	if (fontflag == 0) {
		/* {ꃍ[h */
		lib_loadfontset1(0xc0ffffff, 0, 2);
		lib_waitsignal(0x0001, 0, 0);
		getsignal();
		lib_makecharset(0, 0x0210, 0x0021, 0x1000000, 0, 0);
		lib_makecharset(0, 0x0250, 0, 0, 0, 0);
		fontflag++;
	}

	/* VOi` */
	lib_definesignal1p0(3, 0x0100, 0x00ac,           window,  4); // J[\L[
	lib_definesignal1p0(1, 0x0100, 0x00a8,           window,  8); // PageUp, Down
	lib_definesignal1p0(3, 0x0100, 0x307010ac,       window, 10); // Shift+Ctrl+J[\
	lib_definesignal1p0(3, 0x0100, 0x307090ac,       window, 10); // (CN)
	lib_definesignal1p0(0, 0x0100, 0x20701000 | 'O', window, 14); // Ctrl+O
	/* sig15  */
	/* sig16~31: t@CI[vp */
	/* sig40: WindowN[Yʒm */
	lib_definesignal0p0(0, 0, 0, 0);

	/* Value, Field */
	lib_opentextbox_nm(0, value, 0, TBOX_X, 1,  0, 0, window, 0x0210, 0);
	lib_opengraphbox_nm(1, field, 1, 15, GBOX_X, GBOX_Y, 0, 16, window);

	/* XN[o[ */
	scroll_init(tate, 0, window, field, WRKSEAT_X + 1, 16, WRKSEAT_X + 1, 0, 16, WRKSEAT_Y + 1, GBOX_X);
	scroll_init(yoko, 1, window, field, 0, WRKSEAT_Y + 17, 0, WRKSEAT_Y + 1, WRKSEAT_X + 1, 16, GBOX_X);
	scroll_kado(tate, yoko);

	/* [NV[g쐬 */
	for (i=0; i<GBOX_X; i+=CELLSIZ_X)
		lib_drawline0(0, field, 7, i, 0, i, GBOX_Y - 17);
	for (i=0; i<GBOX_Y; i+=CELLSIZ_Y)
		lib_drawline0(0, field, 7, 0, i, GBOX_X-1 - 17, i);

	return;
}


const int getsignal()
/* 0ԂꂽVOiȂ */
{
    int signal;
    if (*sig_ptr == REWIND_CODE) {
        lib_waitsignal(0x0000, *(sig_ptr + 1), 0);
        sig_ptr = signalbox0;
    }
    signal = *sig_ptr;
    if (signal != 0) {
        sig_ptr++;
        lib_waitsignal(0x0000, 1, 0);
    }
    return signal;
}

/* ---------------------------------------------------------------- */
